diff -Nru sogo-5.0.1/UI/WebServerResources/js/Mailer/sgMessageListItemMain.directive.js sogo-5.2.0/UI/WebServerResources/js/Mailer/sgMessageListItemMain.directive.js
--- sogo-5.0.1/UI/WebServerResources/js/Mailer/sgMessageListItemMain.directive.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Mailer/sgMessageListItemMain.directive.js	2021-08-18 21:35:57.000000000 +0200
@@ -24,6 +24,7 @@
         '    <div class="sg-tile-date"><!-- date --></div>',
         '  </div>',
         '  <div class="sg-md-body">',
+        '    <div class="sg-category-dot-container"><!-- categories --></div>',
         '    <div class="sg-tile-subject"><!-- subject --></div>',
         '    <div class="sg-tile-size"><!-- size --></div>',
         '    <md-button class="sg-tile-btn md-secondary ng-hide" md-colors="::{ color: \'accent-600\'}" ng-click="$ctrl.toggleThread()">',
@@ -120,70 +121,73 @@
         var i;
         $ctrl.message = $ctrl.parentController.message;
 
-        // Flags
-        var flagElements = $mdUtil.nodesToArray($element[0].querySelectorAll('.sg-category'));
-        _.forEach(flagElements, function(flagElement) {
-          $element[0].removeChild(flagElement);
-        });
-        for (i = 0; i < $ctrl.message.flags.length && i < 5; i++) {
-          var tag = $ctrl.message.flags[i];
-          if ($ctrl.service.$tags[tag]) {
-            var flagElement = angular.element('<div class="sg-category"></div>');
-            flagElement.css('left', (i*3) + 'px');
-            flagElement.css('background-color', $ctrl.service.$tags[tag][1]);
-            $element.prepend(flagElement);
+        if (!$ctrl.message.loading) {
+          // Flags
+          var flagList = $element[0].querySelector('.sg-category-dot-container'),
+              $flagList = angular.element(flagList),
+              flagElements = $mdUtil.nodesToArray(flagList.querySelectorAll('.sg-category-dot'));
+          _.forEach(flagElements, function(flagElement) {
+            flagList.removeChild(flagElement);
+          });
+          for (i = 0; i < $ctrl.message.flags.length && i < 5; i++) {
+            var tag = $ctrl.message.flags[i];
+            if ($ctrl.service.$tags[tag]) {
+              var flagElement = angular.element('<div class="sg-category-dot"></div>');
+              flagElement.css('background-color', $ctrl.service.$tags[tag][1]);
+              $flagList.append(flagElement);
+            }
           }
-        }
 
-        // Mailbox name when in virtual mode
-        if ($ctrl.mailboxNameElement)
-          $ctrl.mailboxNameElement.innerHTML = $ctrl.message.$mailbox.$displayName;
-
-        // Sender or recipient when in
-        if ($ctrl.MailboxService.selectedFolder.isSentFolder)
-          $ctrl.senderElement.innerHTML = $ctrl.message.$shortAddress('to').encodeEntities();
-        else
-          $ctrl.senderElement.innerHTML = $ctrl.message.$shortAddress('from').encodeEntities();
-
-        // Priority icon
-        if ($ctrl.message.priority && $ctrl.message.priority.level < 3) {
-          $ctrl.priorityIconElement.classList.remove('ng-hide');
-          if ($ctrl.message.priority.level < 2)
-            $ctrl.priorityIconElement.classList.add('md-warn');
+          // Mailbox name when in virtual mode
+          if ($ctrl.mailboxNameElement)
+            $ctrl.mailboxNameElement.innerHTML = $ctrl.message.$mailbox.$displayName;
+
+          // Sender or recipient when in
+          if ($ctrl.MailboxService.selectedFolder.isSentFolder)
+            $ctrl.senderElement.innerHTML = $ctrl.message.$shortAddress('to').encodeEntities();
           else
-            $ctrl.priorityIconElement.classList.remove('md-warn');
-        }
-        else
-          $ctrl.priorityIconElement.classList.add('ng-hide');
+            $ctrl.senderElement.innerHTML = $ctrl.message.$shortAddress('from').encodeEntities();
 
-        // Mail thread
-        if ($ctrl.message.first) {
-          $ctrl.threadButton.classList.remove('ng-hide');
-          $ctrl.threadCountElement.innerHTML = $ctrl.message.threadCount;
-          if ($ctrl.message.collapsed)
-            $ctrl.threadIconElement.classList.remove('md-rotate-180-ccw');
-        }
-        else {
-          $ctrl.threadButton.classList.add('ng-hide');
-        }
+          // Priority icon
+          if ($ctrl.message.priority && $ctrl.message.priority.level < 3) {
+            $ctrl.priorityIconElement.classList.remove('ng-hide');
+            if ($ctrl.message.priority.level < 2)
+              $ctrl.priorityIconElement.classList.add('md-warn');
+            else
+              $ctrl.priorityIconElement.classList.remove('md-warn');
+          }
+          else
+            $ctrl.priorityIconElement.classList.add('ng-hide');
 
-        // Subject
-        $ctrl.subjectElement.innerHTML = $ctrl.message.subject.encodeEntities();
+          // Mail thread
+          if ($ctrl.message.first) {
+            $ctrl.threadButton.classList.remove('ng-hide');
+            $ctrl.threadCountElement.innerHTML = $ctrl.message.threadCount;
+            if ($ctrl.message.collapsed)
+              $ctrl.threadIconElement.classList.remove('md-rotate-180-ccw');
+          }
+          else {
+            $ctrl.threadButton.classList.add('ng-hide');
+          }
 
-        // Message size
-        $ctrl.sizeElement.innerHTML = $ctrl.message.size;
+          // Subject
+          $ctrl.subjectElement.innerHTML = $ctrl.message.subject.encodeEntities();
 
-        // Received Date
-        $ctrl.dateElement.innerHTML = $ctrl.message.relativedate;
+          // Message size
+          $ctrl.sizeElement.innerHTML = $ctrl.message.size;
 
-        setVisibility($ctrl.flagIconElement,
-                       $ctrl.message.isflagged);
-        setVisibility($ctrl.answerIconElement,
-                       $ctrl.message.isanswered);
-        setVisibility($ctrl.forwardIconElement,
-                       $ctrl.message.isforwarded);
-        setVisibility($ctrl.attachmentIconElement,
-                       $ctrl.message.hasattachment);
+          // Received Date
+          $ctrl.dateElement.innerHTML = $ctrl.message.relativedate;
+
+          setVisibility($ctrl.flagIconElement,
+                        $ctrl.message.isflagged);
+          setVisibility($ctrl.answerIconElement,
+                        $ctrl.message.isanswered);
+          setVisibility($ctrl.forwardIconElement,
+                        $ctrl.message.isforwarded);
+          setVisibility($ctrl.attachmentIconElement,
+                        $ctrl.message.hasattachment);
+        }
 
         // Call original method on parent controller
         angular.bind($ctrl.parentController, parentControllerOnUpdate)();
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Mailer/VirtualMailbox.service.js sogo-5.2.0/UI/WebServerResources/js/Mailer/VirtualMailbox.service.js
--- sogo-5.0.1/UI/WebServerResources/js/Mailer/VirtualMailbox.service.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Mailer/VirtualMailbox.service.js	2021-08-18 21:35:57.000000000 +0200
@@ -122,7 +122,7 @@
    */
   VirtualMailbox.prototype.resetSelectedMessage = function() {
     _.forEach(this.$mailboxes, function(mailbox) {
-      delete mailbox.selectedMessage;
+      delete mailbox.$selectedMessage;
     });
   };
 
@@ -134,7 +134,7 @@
    */
   VirtualMailbox.prototype.hasSelectedMessage = function() {
     return angular.isDefined(_.find(this.$mailboxes, function(mailbox) {
-      return angular.isDefined(mailbox.selectedMessage);
+      return angular.isDefined(mailbox.$selectedMessage);
     }));
   };
 
@@ -148,7 +148,7 @@
    */
   VirtualMailbox.prototype.isSelectedMessage = function(messageId, mailboxPath) {
     return angular.isDefined(_.find(this.$mailboxes, function(mailbox) {
-      return mailbox.path == mailboxPath && mailbox.selectedMessage == messageId;
+      return mailbox.path == mailboxPath && mailbox.$selectedMessage == messageId;
     }));
   };
 
@@ -216,7 +216,7 @@
   VirtualMailbox.prototype.$selectedMessageIndex = function() {
     var offset = 0;
     var selectedMailbox = _.find(this.$mailboxes, function(mailbox) {
-      if (angular.isDefined(mailbox.selectedMessage)) {
+      if (angular.isDefined(mailbox.$selectedMessage)) {
         return true;
       }
       else {
@@ -224,7 +224,7 @@
         return false;
       }
     });
-    return offset + selectedMailbox.uidsMap[selectedMailbox.selectedMessage];
+    return offset + selectedMailbox.uidsMap[selectedMailbox.$selectedMessage];
   };
 
   /**
@@ -233,23 +233,23 @@
    * @desc Return an associative array of the selected messages for each mailbox. Keys are the mailboxes ids.
    * @returns an associative array
    */
-  VirtualMailbox.prototype.$selectedMessages = function() {
+  VirtualMailbox.prototype.selectedMessages = function() {
     var messagesMap = {};
     return _.filter(_.transform(this.$mailboxes, function(messagesMap, mailbox) {
-      messagesMap[mailbox.id] = mailbox.$selectedMessages();
+      messagesMap[mailbox.id] = mailbox.$selectedMessages;
     }, {}), function(o) {
       return _.size(o) > 0;
     });
   };
 
   /**
-   * @function $selectedCount
+   * @function selectedCount
    * @memberof VirtualMailbox.prototype
    * @desc Return the number of messages selected by the user.
    * @returns the number of selected messages
    */
-  VirtualMailbox.prototype.$selectedCount = function() {
-    return _.sum(_.invokeMap(this.$mailboxes, '$selectedCount'));
+  VirtualMailbox.prototype.selectedCount = function() {
+    return _.sum(_.invokeMap(this.$mailboxes, 'selectedCount'));
   };
 
   /**
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Main/Main.app.js sogo-5.2.0/UI/WebServerResources/js/Main/Main.app.js
--- sogo-5.0.1/UI/WebServerResources/js/Main/Main.app.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Main/Main.app.js	2021-08-18 21:35:57.000000000 +0200
@@ -17,6 +17,7 @@
       this.creds = {
         username: $window.cookieUsername,
         password: null,
+        domain: null,
         rememberLogin: angular.isDefined($window.cookieUsername) && $window.cookieUsername.length > 0
       };
       // Send selected language only if user has changed it
@@ -24,9 +25,12 @@
         this.creds.language = $window.language;
       this.loginState = false;
 
-      // Code pattern for Google verification code
+      // Code pattern for TOTP verification code
       this.verificationCodePattern = '\\d{6}';
 
+      // Password policy - change expired password
+      this.passwords = { newPassword: null, newPasswordConfirmation: null, oldPassword: null };
+
       // Show login once everything is initialized
       this.showLogin = false;
       $timeout(function() { vm.showLogin = true; }, 100);
@@ -37,24 +41,61 @@
       Authentication.login(vm.creds)
         .then(function(data) {
 
-          if (data.gamissingkey) {
-            vm.loginState = 'googleauthenticatorcode';
+          if (data.totpmissingkey) {
+            vm.loginState = 'totpcode';
           }
           else {
             vm.loginState = 'logged';
             vm.cn = data.cn;
+            vm.url = data.url;
 
             // Let the user see the succesfull message before reloading the page
             $timeout(function() {
-              if ($window.location.href === data.url)
-                $window.location.reload(true);
-              else
-                $window.location.href = data.url;
+              vm.continueLogin();
             }, 1000);
           }
         }, function(msg) {
           vm.loginState = 'error';
-          vm.errorMessage = msg.error;
+
+          if (msg.error) {
+            vm.errorMessage = msg.error;
+          }
+          else if (msg.grace > 0) {
+            // Password is expired, grace logins limit is not yet reached
+            vm.loginState = 'passwordwillexpire';
+            vm.cn = msg.cn;
+            vm.url = msg.url;
+            vm.errorMessage = l('You have %{0} logins remaining before your account is locked. Please change your password in the preference dialog.', msg.grace);
+          }
+          else if (msg.expire > 0) {
+            // Password will soon expire
+            var value, string;
+            if (msg.expire > 86400) {
+              value = Math.round(msg.expire/86400);
+              string = l("days");
+            }
+            else if (msg.expire > 3600) {
+              value = Math.round(msg.expire/3600);
+              string = l("hours");
+            }
+            else if (msg.expire > 60) {
+              value = Math.round(msg.expire/60);
+              string = l("minutes");
+            }
+            else {
+              value = msg.expire;
+              string = l("seconds");
+            }
+            vm.loginState = 'passwordwillexpire';
+            vm.cn = msg.cn;
+            vm.url = msg.url;
+            vm.errorMessage = l('Your password is going to expire in %{0} %{1}.', value, string);
+          }
+          else if (msg.passwordexpired) {
+            vm.loginState = 'passwordexpired';
+            vm.url = msg.url;
+          }
+
         });
       return false;
     };
@@ -64,6 +105,13 @@
       delete vm.creds.verificationCode;
     };
 
+    this.continueLogin = function() {
+      if ($window.location.href === vm.url)
+        $window.location.reload(true);
+      else
+        $window.location.href = vm.url;
+    };
+
     this.showAbout = function($event) {
       $mdDialog.show({
         targetEvent: $event,
@@ -83,6 +131,36 @@
       // Reload page
       $window.location.href = ApplicationBaseURL + 'login?language=' + this.creds.language;
     };
+
+    this.canChangePassword = function(form) {
+      if (this.passwords.newPasswordConfirmation && this.passwords.newPasswordConfirmation.length &&
+          this.passwords.newPassword != this.passwords.newPasswordConfirmation) {
+        form.newPasswordConfirmation.$setValidity('newPasswordMismatch', false);
+        return false;
+      }
+      else {
+        form.newPasswordConfirmation.$setValidity('newPasswordMismatch', true);
+      }
+      if (this.passwords.newPassword && this.passwords.newPassword.length > 0 &&
+          this.passwords.newPasswordConfirmation && this.passwords.newPasswordConfirmation.length &&
+          this.passwords.newPassword == this.passwords.newPasswordConfirmation &&
+          this.passwords.oldPassword && this.passwords.oldPassword.length > 0)
+        return true;
+
+      return false;
+    };
+
+    this.changePassword = function() {
+      Authentication.changePassword(this.creds.username, this.creds.domain, this.passwords.newPassword, this.passwords.oldPassword).then(function(data) {
+        vm.loginState = 'message';
+        vm.url = data.url;
+        vm.errorMessage = l('The password was changed successfully.');
+      }, function(msg) {
+        vm.loginState = 'error';
+        vm.errorMessage = msg;
+      });
+    };
+
   }
 
   angular
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Preferences/AccountDialogController.js sogo-5.2.0/UI/WebServerResources/js/Preferences/AccountDialogController.js
--- sogo-5.0.1/UI/WebServerResources/js/Preferences/AccountDialogController.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Preferences/AccountDialogController.js	2021-08-18 21:35:57.000000000 +0200
@@ -74,6 +74,10 @@
       }
     };
 
+    this.hasDefaultIdentity = function() {
+      return _.findIndex(this.account.identities, function(identity) { return !!identity.isDefault; }) >= 0;
+    };
+
     this.setDefaultIdentity = function ($event, $index) {
       _.forEach(this.account.identities, function(identity, i) {
         if (i == $index)
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Preferences/PreferencesController.js sogo-5.2.0/UI/WebServerResources/js/Preferences/PreferencesController.js
--- sogo-5.0.1/UI/WebServerResources/js/Preferences/PreferencesController.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Preferences/PreferencesController.js	2021-08-18 21:35:57.000000000 +0200
@@ -356,10 +356,7 @@
 
       domains = [];
 
-      if ($window.forwardConstraints > 0 &&
-          angular.isDefined(Preferences.defaults.Forward) &&
-          Preferences.defaults.Forward.enabled &&
-          angular.isDefined(Preferences.defaults.Forward.forwardAddress)) {
+      if ($window.forwardConstraints > 0) {
 
         // We first extract the list of 'known domains' to SOGo
         defaultAddresses = $window.defaultEmailAddresses;
@@ -396,7 +393,8 @@
       // We do some sanity checks
 
       // We check if we're allowed or not to forward based on the domain defaults
-      if (this.preferences.defaults.Forward && this.preferences.defaults.Forward.forwardAddress) {
+      if (this.preferences.defaults.Forward && this.preferences.defaults.Forward.enabled &&
+          this.preferences.defaults.Forward.forwardAddress) {
         addresses = this.preferences.defaults.Forward.forwardAddress;
         try {
           for (i = 0; i < addresses.length; i++) {
@@ -486,7 +484,7 @@
     };
 
     this.changePassword = function() {
-      Authentication.changePassword(this.passwords.newPassword, this.passwords.oldPassword).then(function() {
+      Authentication.changePassword(null, null, this.passwords.newPassword, this.passwords.oldPassword).then(function() {
         var alert = $mdDialog.alert({
           title: l('Password'),
           textContent: l('The password was changed successfully.'),
@@ -499,7 +497,7 @@
       }, function(msg) {
         var alert = $mdDialog.alert({
           title: l('Password'),
-          content: msg,
+          textContent: msg,
           ok: l('OK')
         });
         $mdDialog.show( alert )
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Preferences/Preferences.service.js sogo-5.2.0/UI/WebServerResources/js/Preferences/Preferences.service.js
--- sogo-5.0.1/UI/WebServerResources/js/Preferences/Preferences.service.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Preferences/Preferences.service.js	2021-08-18 21:35:57.000000000 +0200
@@ -1,6 +1,7 @@
 /* -*- Mode: javascript; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
 
 (function() {
+  /* jshint loopfunc: true */
   'use strict';
 
   /**
@@ -386,38 +387,50 @@
     if (this.nextInboxPoll)
       Preferences.$timeout.cancel(this.nextInboxPoll);
 
-    Preferences.$$resource.post('Mail', '0/folderINBOX/view', params).then(function(data) {
-      var uids = data.uids;
-      var uidHeaderIndex = data.headers[0].indexOf('uid');
-      var fromHeaderIndex = data.headers[0].indexOf('From');
-      var subjectHeaderIndex = data.headers[0].indexOf('Subject');
-      if (data.threaded) {
-        data.uids.splice(0, 1);
-        uids = _.map(data.uids, 0);
-      }
-      if (_this.lastUid) {
-        _.find(uids, function (uid, index) {
-          var headers, id, href, toast;
-          if (uid > _this.lastUid) {
+    if (this.inboxSyncToken)
+      params.syncToken = this.inboxSyncToken;
+
+    Preferences.$$resource.post('Mail', '0/folderINBOX/changes', params).then(function(data) {
+      if (data.syncToken) {
+        _this.inboxSyncToken = data.syncToken;
+        Preferences.$log.debug("New syncToken is " + _this.inboxSyncToken);
+      }
+
+      if (angular.isDefined(data.headers) && data.headers.length > 0) {
+        var uidHeaderIndex = data.headers[0].indexOf('uid');
+        var isReadHeaderIndex = data.headers[0].indexOf('isRead');
+        var fromHeaderIndex = data.headers[0].indexOf('From');
+        var subjectHeaderIndex = data.headers[0].indexOf('Subject');
+        var i;
+        var showToast = function() {
+          var _this = this;
+          return Preferences.$toast.show(this)
+            .then(function(response) {
+              if (response === 'ok') {
+                _this.viewInboxMessage(_this.locals.uid);
+              }
+            });
+        };
+        for (i = 1; i < data.headers.length; i++) {
+          var headers = data.headers[i],
+              uid = headers[uidHeaderIndex],
+              id, href, toast;
+          if (!headers[isReadHeaderIndex]) {
             // New unseen message
             Preferences.$log.debug('Show notification for message ' + uid);
-            headers = _.find(data.headers, function(h) {
-              return h[uidHeaderIndex] == uid;
-            });
             if (_this.defaults.SOGoDesktopNotifications) {
               id = 'mail-inbox-' + uid;
               href = Preferences.$state.href('mail.account.mailbox.message', { accountId: 0, mailboxId: 'INBOX', messageId: uid });
               _this.createNotification(id, headers[subjectHeaderIndex], {
                 body: headers[fromHeaderIndex][0].name || headers[fromHeaderIndex][0].email,
                 icon: '/SOGo.woa/WebServerResources/img/email-256px.png',
-                onClick: function () {
-                  _this.viewInboxMessage(uid);
-                }
+                onClick: angular.bind(_this, _this.viewInboxMessage, uid)
               });
             }
             else {
               toast = {
                 locals: {
+                  uid: uid,
                   title: headers[subjectHeaderIndex],
                   body: headers[fromHeaderIndex][0].name || headers[fromHeaderIndex][0].email
                 },
@@ -440,28 +453,13 @@
                 ].join(''),
                 position: 'top right',
                 hideDelay: 5000,
-                controller: toastController
+                controller: toastController,
+                viewInboxMessage: _this.viewInboxMessage
               };
-              _this.currentToast = _this.currentToast.then(function () {
-                return Preferences.$toast.show(toast)
-                .then(function(response) {
-                  if (response === 'ok') {
-                    _this.viewInboxMessage(uid);
-                  }
-                });
-              });
+              _this.currentToast = _this.currentToast.then(angular.bind(toast, showToast));
             }
-            return false; // Continue to next unseen message
-          }
-          else {
-            return true; // No more new messages
           }
-        });
-        if (uids[0] > _this.lastUid) {
-          _this.lastUid = uids[0];
         }
-      } else {
-        _this.lastUid = uids[0];
       }
     }).finally(function () {
       var refreshViewCheck = _this.defaults.SOGoRefreshViewCheck;
@@ -629,7 +627,7 @@
           Preferences.$toast.hide();
         };
         scope.snooze = function() {
-          Preferences.$$resource.fetch(url, 'view?snoozeAlarm=' + scope.reminder);
+          Preferences.$$resource.fetch('Calendar/' + url, 'view?snoozeAlarm=' + scope.reminder);
           Preferences.$toast.hide();
         };
       }
@@ -674,6 +672,9 @@
       }
     });
 
+    // Don't push locale definition
+    delete preferences.defaults.locale;
+
     // Merge back mail labels keys and values
     preferences.defaults.SOGoMailLabelsColors = {};
     _.forEach(preferences.defaults.SOGoMailLabelsColorsKeys, function(key, i) {
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Scheduler/Attendees.service.js sogo-5.2.0/UI/WebServerResources/js/Scheduler/Attendees.service.js
--- sogo-5.0.1/UI/WebServerResources/js/Scheduler/Attendees.service.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Scheduler/Attendees.service.js	2021-08-18 21:35:57.000000000 +0200
@@ -136,7 +136,7 @@
    * @param {Object} card - an Card object instance to be added to the attendees list
    */
   Attendees.prototype.add = function(card, options) {
-    var _this = this, attendee, list, url, params;
+    var _this = this, attendee, list, url, params, promise = Attendees.$q.when();
     if (card) {
       if (!this.component.attendees || (options && options.organizerCalendar)) {
         // No attendee yet; initialize the organizer
@@ -145,7 +145,7 @@
       if (card.$isList({expandable: true})) {
         // Decompose list members
         list = Attendees.$Card.$find(card.container, card.c_name);
-        list.$id().then(function(listId) {
+        promise = list.$id().then(function(listId) {
           _.forEach(list.refs, function(ref) {
             attendee = {
               name: ref.c_cn,
@@ -189,7 +189,7 @@
         })) {
           if (card.$isList() && Attendees.$Preferences.defaults.SOGoLDAPGroupExpansionEnabled) {
             // LDAP list -- preload members
-            card.$members().then(function(members) {
+            promise = card.$members().then(function(members) {
               attendee.members = members;
               attendee.isExpandableGroup = true;
             });
@@ -205,6 +205,8 @@
         }
       }
     }
+
+    return promise;
   };
 
   /**
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Scheduler/ComponentController.js sogo-5.2.0/UI/WebServerResources/js/Scheduler/ComponentController.js
--- sogo-5.0.1/UI/WebServerResources/js/Scheduler/ComponentController.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Scheduler/ComponentController.js	2021-08-18 21:35:57.000000000 +0200
@@ -128,10 +128,11 @@
       // Retrieve master event
       component = Calendar.$get(this.component.pid).$getComponent(this.component.id);
       component.$futureComponentData.then(function() {
-        // Propagate the participant status and alarm to the master event
+        // Propagate the participant status, classification and alarm to the master event
         component.reply = vm.component.reply;
         component.delegatedTo = vm.component.delegatedTo;
         component.$hasAlarm = vm.component.$hasAlarm;
+        component.classification = vm.component.classification;
         component.alarm = vm.component.alarm;
         // Send reply to the server
         vm.reply(component);
@@ -205,8 +206,8 @@
   /**
    * @ngInject
    */
-  ComponentEditorController.$inject = ['$rootScope', '$scope', '$log', '$timeout', '$window', '$element', '$mdDialog', '$mdToast', 'sgFocus', 'User', 'CalendarSettings', 'Calendar', 'Component', 'Attendees', 'AddressBook', 'Card', 'Preferences', 'stateComponent'];
-  function ComponentEditorController($rootScope, $scope, $log, $timeout, $window, $element, $mdDialog, $mdToast, focus, User, CalendarSettings, Calendar, Component, Attendees, AddressBook, Card, Preferences, stateComponent) {
+  ComponentEditorController.$inject = ['$rootScope', '$scope', '$q', '$log', '$timeout', '$window', '$element', '$mdDialog', '$mdToast', 'sgFocus', 'User', 'CalendarSettings', 'Calendar', 'Component', 'Attendees', 'AddressBook', 'Card', 'Preferences', 'stateComponent'];
+  function ComponentEditorController($rootScope, $scope, $q, $log, $timeout, $window, $element, $mdDialog, $mdToast, focus, User, CalendarSettings, Calendar, Component, Attendees, AddressBook, Card, Preferences, stateComponent) {
     var vm = this, component, oldStartDate, oldEndDate, oldDueDate, dayStartTime, dayEndTime;
 
     this.$onInit = function () {
@@ -280,7 +281,7 @@
     this.changeCalendar = function () {
       var updateRequired = (this.component.attendees && this.component.attendees.length > 0);
       if (updateRequired)
-        this.component.initOrganizer(Calendar.$get(this.component.destinationCalendar));
+        this.component.$attendees.initOrganizer(Calendar.$get(this.component.destinationCalendar));
     };
 
     // Autocomplete cards for attendees
@@ -291,7 +292,8 @@
     this.addAttendee = function (card, partial) {
       var initOrganizer = (!this.component.attendees || this.component.attendees.length === 0),
           destinationCalendar = Calendar.$get(this.component.destinationCalendar),
-          options = initOrganizer? { organizerCalendar: destinationCalendar } : {};
+          options = initOrganizer? { organizerCalendar: destinationCalendar } : {},
+          promises = [];
       var emailRE = /([\w\!\#$\%\&\'\*\+\-\/\=\?\^\`{\|\}\~]+\.)*[\w\!\#$\%\&\'\*\+\-\/\=\?\^\`{\|\}\~]+@((((([a-z0-9]{1}[a-z0-9\-]{0,62}[a-z0-9]{1})|[a-z])\.)+[a-z]{2,})|(\d{1,3}\.){3}\d{1,3}(\:\d{1,5})?)/i,
           i, address;
       if (partial) options.partial = partial;
@@ -316,7 +318,7 @@
 
       function addCard(newCard) {
         if (!vm.component.$attendees.hasAttendee(newCard))
-          vm.component.$attendees.add(newCard, options);
+          return vm.component.$attendees.add(newCard, options);
       }
 
       if (angular.isString(card)) {
@@ -332,23 +334,27 @@
                card.charCodeAt(i) == 44 ||   // ,
                card.charCodeAt(i) == 59) &&  // ;
               emailRE.test(address)) {
-            createCard(address).then(addCard);
+            promises.push(createCard(address).then(addCard));
             address = '';
           }
           else {
             address += card.charAt(i);
           }
         }
-        if (address && emailRE.test(address))
-          createCard(address).then(addCard);
+        if (address && emailRE.test(address)) {
+          promises.push(createCard(address).then(addCard));
+        }
       }
       else if (angular.isDefined(card)) {
         if (!this.component.$attendees.hasAttendee(card))
-          this.component.$attendees.add(card, options);
+          promises.push(this.component.$attendees.add(card, options));
         this.showAttendeesEditor |= initOrganizer;
       }
 
-      $timeout(scrollToStart);
+      if (_.has(this.component, '$attendees'))
+        $timeout(scrollToStart);
+
+      return $q.all(promises);
     };
 
     function scrollToStart() {
@@ -466,20 +472,21 @@
       this.adjustStartTime();
       this.adjustEndTime();
       this.changeAlarmRelation(form);
-      if (form.$valid) {
-        this.component.$save(options)
-          .then(function(data) {
-            $rootScope.$emit('calendars:list');
-            Preferences.getAlarms();
-            $mdDialog.hide();
-          }, function(response) {
-            if (response.status == CalendarSettings.ConflictHTTPErrorCode &&
-                _.isObject(response.data.message))
-              vm.attendeeConflictError = response.data.message;
-            else
-              vm.edit(form);
-          });
-      }
+      this.addAttendee(this.searchText).then(function () {
+        if (form.$valid) {
+          vm.component.$save(options)
+            .then(function(data) {
+              $rootScope.$emit('calendars:list');
+              Preferences.getAlarms();
+              $mdDialog.hide();
+            }, function(response) {
+              if (response.status == CalendarSettings.ConflictHTTPErrorCode)
+                vm.attendeeConflictError = _.isObject(response.data.message) ? response.data.message : { reject: response.data.message };
+              else
+                vm.edit(form);
+            });
+        }
+      });
     };
 
     this.reset = function (form) {
@@ -623,9 +630,11 @@
     };
 
     function updateFreeBusy() {
-      vm.component.$attendees.updateFreeBusyCoverage();
-      vm.component.$attendees.updateFreeBusy();
-      $timeout(scrollToStart);
+      if (_.has(vm.component, '$attendees')) {
+        vm.component.$attendees.updateFreeBusyCoverage();
+        vm.component.$attendees.updateFreeBusy();
+        $timeout(scrollToStart);
+      }
     }
   }
 
